var NCOWebtopForm = null; // gets set in init
var NCOWebtopFormName = "toolname";


var NCOWebtopWindowParams = "location=no,status=no,height=400,width=300,scrollbar=yes";
var NCOWebtopOpenFieldsWindowURL = null;

var NCOWebtopNameMessage = "Please provide a name for this tool";
var NCOWebtopSQLMessage = "Please provide SQL text for this tool";
var NCOWebtopJournalMessage = "Please provide a journal for this tool";
var NCOWebtopACLsMessage = "No users will be able to use this tool as you have not provided any \nAccess Control Lists for this tool, would you like to add ACLs to this tool?";
var NCOWebtopURLMessage = "Please provide a URL for this tool";
var NCOWebtopPlatformsMessage = "No users will be able to use this tool as you have not provided any \nplatform for this tool, would you like to add platform to this tool?";
var NCOWebtopBadParamsMessage = "Parameters must not contain spaces within the curly brackets. Please rectify the following:";

var NCOWebtopTextHiliteColour = "red";
var NCOWebtopTextDeHiliteColour = "black";

//******************************************************************************************
function NCOWebtopInit()
{
	NCOWebtopForm = document.forms[ "tool" ];
	NCOWebtopURLBase = document.location;
	NCOWebtopOpenFieldsWindowURL = "/Admin/tools/FieldsDialog/";
	NCOWebtopOpenAclsWindowURL = "/Admin/Dialogs/ACLDialog/?type=2&formname=tool";
	
}


//******************************************************************************************
function NCOWebtopUpdateTarget( source , destination )
{
	if ( NCOWebtopForm.elements[ source ].options.selectedIndex == 0 )
	{
		NCOWebtopForm.elements[ destination ].disabled = true;
	}
	else
	{
		NCOWebtopForm.elements[ destination ].disabled = false;
	}
}

//******************************************************************************************
function NCOWebtopShowFieldsDialog()
{
	window.open( NCOWebtopOpenFieldsWindowURL , "toolSelectFields" , NCOWebtopWindowParams );
}

//******************************************************************************************
function NCOWebtopShowAclsDialog()
{
	window.open( NCOWebtopOpenAclsWindowURL , "aclSelectFields" , NCOWebtopWindowParams );
}

//******************************************************************************************
function NCOWebtopUpdateFields( fieldsArray )
{
	var size = fieldsArray.length;
	var newString = "";
	var i = 0;
	if ( size == 0 )
	{
		NCOWebtopForm.elements[ "fields" ].value = "";
		return;
	}
	else if ( size > 1 )
	{
		for ( i =0 ; i < ( size - 1 ); i++ )
		{
			newString += ( fieldsArray[ i ] + "," );
		}
	}
	newString += ( fieldsArray[ size - 1 ] );
	NCOWebtopForm.elements[ "fields" ].value = newString;
}
document.NCOWebtopUpdateFields = NCOWebtopUpdateFields;

//******************************************************************************************
function NCOWebtopDecodeArray( baseArray )
{
	var i = 0;
	var size = baseArray.length;
	for ( i = 0 ; i < size ; i++ )
	{
		 // baseArray[ i ] = unescape( baseArray[ i ] );
		baseArray[ i ] = baseArray[ i ];
	}
	return baseArray;
}

//******************************************************************************************
function NCOWebtopGetFieldsArray()
{
	if ( NCOWebtopForm.elements[ "fields" ].value == "" )
	{
		return new Array();
	}
        var fieldsString = new String( NCOWebtopForm.elements[ "fields" ].value );

        var fieldsBaseArray = fieldsString.split( "," );
        return NCOWebtopDecodeArray( fieldsBaseArray );      	
}
document.NCOWebtopGetFieldsArray = NCOWebtopGetFieldsArray;

//******************************************************************************************
function NCOWebtopGetAclsArray()
{
	if ( NCOWebtopForm.elements[ "acls" ].value == "" )
	{
		return new Array();
	}
    var aclsString = new String( NCOWebtopForm.elements[ "acls" ].value );
	var aclsBaseArray = aclsString.split( "," );
    return NCOWebtopDecodeArray( aclsBaseArray );      	
}
document.NCOWebtopGetAclsArray = NCOWebtopGetAclsArray;

//******************************************************************************************
function NCOWebtopDoOK()
{
	if ( NCOWebtopValidate() )
	{
		NCOWebtopForm.submit();
	}
}



//******************************************************************************************
function NCOWebtopDoCancel()
{
	window.close();
}


//******************************************************************************************
function NCOWebtopValidate()
{
	if ( NCOWebtopIsSQLTool() )
	{
		if ( !NCOWebtopHasName() )
		{
			alert( NCOWebtopNameMessage );
			return false;
		}
		
		if ( !NCOWebtopHasTextSQL() )
		{
			alert( NCOWebtopSQLMessage );
			return false;
		}
		
		
		if ( !NCOWebtopHasAcls() )
		{
			if ( confirm( NCOWebtopACLsMessage ) )
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		
		
		
		return true;
	}
	if ( NCOWebtopIsCGITool() )
	{
		if ( !NCOWebtopHasName() )
		{
			alert( NCOWebtopNameMessage );
			return false;
		}
		else if ( !NCOWebtopHasURL() )
		{
			alert( NCOWebtopURLMessage );
			return false;	
		}
		else if ( !NCOWebtopCurlyParamsAreOK(
			NCOWebtopForm.elements[ "url" ] ) )
		{
			return false;
		}
		if ( !NCOWebtopHasAcls() )
		{
			if ( confirm( NCOWebtopACLsMessage ) )
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		return true;
	}
	
	if ( NCOWebtopIsCommandTool() )
	{
		if ( !NCOWebtopHasName() )
		{
			alert( NCOWebtopNameMessage );
			return false;
		}
		else if ( !NCOWebtopCommandsAreOK() )
		{
			return false;
		}
		else if ( !NCOWebtopHasPlatform() )
		{
			if ( confirm( NCOWebtopPlatformsMessage ) )
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		if ( !NCOWebtopHasAcls() )
		{
			if ( confirm( NCOWebtopACLsMessage ) )
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		return true;
	}
	else {
			
		if ( NCOWebtopHasName() )
		{
		NCOWebtopForm.submit();
		}
		else
		{
			alert( NCOWebtopNameMessage );
			return false;
		}
	}
	
}

//******************************************************************************************
function NCOWebtopIsSQLTool()
{
	return NCOWebtopForm.elements[ "tooltype" ].value == "SQL";
}

//******************************************************************************************
function NCOWebtopIsCGITool()
{
	return NCOWebtopForm.elements[ "tooltype" ].value == "CGI";
}

//******************************************************************************************
function NCOWebtopIsCommandTool()
{
	return NCOWebtopForm.elements[ "tooltype" ].value == "COMMAND";
}


//******************************************************************************************
function NCOWebtopHasName()
{
	return ( !( NCOWebtopForm.elements[ "toolname" ].value == "" ) )
}

//******************************************************************************************
function NCOWebtopHasAcls()
{
	return ( !( NCOWebtopForm.elements[ "acls" ].value == "" ) )	
}

//******************************************************************************************
function NCOWebtopHasURL()
{
	return ( !( NCOWebtopIsWhiteSpaceOnly(
		NCOWebtopForm.elements[ "url" ].value ) ) );
}

//******************************************************************************************
function NCOWebtopHasPlatform()
{
	var platformArray = NCOWebtopForm.elements[ "platform" ];
	var size = platformArray.length;
	
	for(i = 0; i < size; i++) {
		if(platformArray[i].checked)
			return true;
	}
	return false
}


//******************************************************************************************
function NCOWebtopHasTextSQL()
{
	return ( !( NCOWebtopForm.elements[ "text-sql" ].value == "" ) )	
}

//******************************************************************************************
function NCOWebtopIsWhiteSpaceOnly( string )
{
	var regex = /^\s*$/;  // Regex to match whitespace(s) or nothing.
	return ( regex.test( string ) );
}

/**
 * Checks that the command lines do not contain parameters that have
 * whitespaces within the bounding curly brackets.
 * @return true if they do not contain whitespaces.
 */
function NCOWebtopCommandsAreOK()
{
	var cmdLineElemsArray = new Array();
	cmdLineElemsArray.push( NCOWebtopForm.elements[ "commandWindows" ] );
	cmdLineElemsArray.push( NCOWebtopForm.elements[ "commandSolaris" ] );
	cmdLineElemsArray.push( NCOWebtopForm.elements[ "commandLinux" ] );
	cmdLineElemsArray.push( NCOWebtopForm.elements[ "commandHPUX" ] );
	cmdLineElemsArray.push( NCOWebtopForm.elements[ "commandAIX" ] );

	for ( var i = 0; i < cmdLineElemsArray.length; i++ )
	{
		if ( !NCOWebtopCurlyParamsAreOK( cmdLineElemsArray[i] ) )
		{
			return false;
		}
	}

	return true;
}

/**
 * Checks that the value of the form element does not contain parameters that
 * have whitespaces within the bounding curly brackets.
 * @return true if there're spaces.
 */
function NCOWebtopCurlyParamsAreOK( formElem )
{
	var formElemStr = formElem.value;

	var paramRegex = /\{\s*[@%$][\w\s]*\}/g;
	var whiteSpaceRegex = /\s+/;

	var regexMatchArray = new Array();
	var badParamsArray = new Array();

	// While there are parameters...
	while ( ( regexMatchArray = paramRegex.exec( formElemStr ) ) != null )
	{
		var matchedParamStr = regexMatchArray[0];

		// If there's whitespace in the parameter...
		if ( whiteSpaceRegex.test( matchedParamStr ) )
		{
			badParamsArray.push( matchedParamStr );
		}
	}

	// If there're incorrect parameters...
	if ( badParamsArray.length > 0 )
	{
		var badParamsStr = "";
		for ( var i = 0; i < badParamsArray.length; i++ )
		{
			badParamsStr += "\n- " + badParamsArray[i];
		}

		formElem.style.color = NCOWebtopTextHiliteColour;
		alert( NCOWebtopBadParamsMessage + badParamsStr );
		formElem.focus();

		return false;
	}
	else
	{
		formElem.style.color = NCOWebtopTextDeHiliteColour;
	}

	return true;
}
