

	//******************************************************
	function NCOWebtopViewDataList( formElement )
	{
		this._formElement = formElement;
		this._dataElements = new Array();
		this._size = 0;
		
		// NBS 27918: This field gets updated only when the Column Title
		// textfield gets focused on. Contains the current selected index.
		this._currIndex = -1
	}

	//******************************************************
	// NBS 27918: This update is needed so that the select list remembers which
	// index the Column Title textfield refers to.
	function updateIndex( )
	{
		this._currIndex = this._formElement.getSelectedIndex();
	}

	//******************************************************
	function update( )
	{
		if ( this._currIndex != -1 )
		{
			return this._dataElements[ this._currIndex ].update();
		}
		return true;
	}

	//******************************************************
	function display( )
	{
		var index = this._formElement.getSelectedIndex();
		if ( index != -1 )
		{
			this._dataElements[ index ].display();
		}	
	}


	//******************************************************
	function addDataItem( dataItem , sortOnAdd , renderOnAdd )
	{
		var insertIndex = this._size;
		if ( dataItem == null )
		{
			return;
		}
		if ( sortOnAdd == true )
		{
//
		}
		dataItem.setFormElement( this._formElement );
		if ( sortOnAdd )
		{
			insertIndex = this.getInsertIndex( dataItem );
		}	
		this.insertDataItem( dataItem , insertIndex , renderOnAdd );	
	}

	//******************************************************
	function updateSelected( oldIndex )
	{
		if ( this._size == 0 )
		{
			this._formElement.setSelectedIndex( -1 );		
		}
		else if ( oldIndex == 0 )
		{
			this._formElement.setSelectedIndex( 0 );
		}
		else if ( oldIndex == this._size )
		{
			this._formElement.setSelectedIndex( oldIndex - 1 );
		}
		else if ( oldIndex == -1 && this._size > 0 )
		{
			this._formElement.setSelectedIndex( 0 );
		}
		else
		{
			this._formElement.setSelectedIndex( oldIndex );
		}
		this.displaySelectedOption();
	}

	//******************************************************
	function removeSelectedItem()
	{
		var index = this._formElement.getSelectedIndex();
		if ( index != -1 )
		{
			return this.removeItem( index );
		}
		else
		{
			return null;
		}
	}

	//******************************************************
	function removeItem( index )
	{
		var dataItem = this._dataElements[ index ];
		this.shiftDataUpFrom( index );
		this.renderFrom( index , this._size );
		this._formElement.removeLastElement();
		this.updateSelected( index );
		this._dataElements.length--;
		return dataItem;
	} 

	//******************************************************
	function removeAllDataItems( )
	{
		var items = this._dataElements;
		this._formElement.clearAllData();
		this._size = 0;
		this._dataElements = new Array();
		return items;
	}

	//******************************************************
	function moveListItemToTop()
	{
		var index = this._formElement.getSelectedIndex();
		var numOfOptions =  this._formElement.getOptionCount();
		var dataItem = null;

		if ( index > 0 && numOfOptions > 1 )
		{
			dataItem = this.removeItem(  index );
			this.insertDataItem( dataItem , 0 , true );
			this._formElement.setSelectedIndex( 0 );
			this.updateSelected( 0 );
		}

	}

	//******************************************************
	function moveListItemToBottom()
	{
		var index = this._formElement.getSelectedIndex();
		var numOfOptions =  this._formElement.getOptionCount();
		var insertIndex = null;
		if ( ( index < ( numOfOptions - 1 ) ) && numOfOptions > 1 )
		{
			insertIndex = this._size - 1;
			dataItem = this.removeItem( index );
			this.insertDataItem( dataItem , insertIndex , true );
			this._formElement.setSelectedIndex( insertIndex   );
			this.updateSelected( insertIndex );
		}
	}

	//******************************************************
	function moveListItemUp()
	{
		var index = this._formElement.getSelectedIndex();
		var numOfOptions =  this._formElement.getOptionCount();
		if ( index > 0 && numOfOptions > 1 )
		{
			this.swapItems( index - 1 , index , index - 1 );			
		}
	}

	//******************************************************
	function moveListItemDown()
	{
		var index = this._formElement.getSelectedIndex();
		var numOfOptions =  this._formElement.getOptionCount();
		if ( ( index < ( numOfOptions - 1 ) ) && numOfOptions > 1 )
		{
			this.swapItems( index , index + 1  , index + 1 );			
		}
	}

	//******************************************************
	function swapItems( firstIndex , secondIndex  , index )
	{
		var firstItem = this._dataElements[ firstIndex ];
		var secondItem = this._dataElements[ secondIndex ];
		
		firstItem.setSequenceNumber( secondIndex );
		secondItem.setSequenceNumber( firstIndex );
		this._dataElements[ firstIndex ] = secondItem;
		this._dataElements[ secondIndex ] = firstItem;

		if ( firstIndex < secondIndex )
		{
			this.renderFrom( firstIndex , secondIndex + 1 );
		}	
		else
		{
			this.renderFrom( secondIndex , firstIndex + 1 );
		}
		this.updateSelected( index );
	}


	//******************************************************
	function addDataItems( dataItems , sortOnAdd )
	{
		var i = 0;
		var index = this._formElement.getSelectedIndex();			

		for ( ; i < dataItems.length ; i++ )
		{
			this.addDataItem( dataItems[ i ]  , sortOnAdd , false );
		}
		this.renderFrom( 0 , this._size );
		this.updateSelected( index );		
	}

	//******************************************************
	function insertDataItem( dataItem , insertIndex , renderOnInsert )
	{
		var index = this._formElement.getSelectedIndex();	
		if ( renderOnInsert == true )
		{
//
		}
		this.shiftDataDownFrom( insertIndex );
		dataItem.setSequenceNumber( insertIndex );		
		this._dataElements[ insertIndex ] = dataItem;
		if ( renderOnInsert )
		{
			this.renderFrom( insertIndex , this._size );
			this.updateSelected( index );
		}

	}


	//******************************************************
	function getInsertIndex( dataItem )
	{
		var insertIndex = this._size;

		var i = 0;
		var insertValue = dataItem.getValue();
		var value = null;
		for ( ; i < this._size ; i++ )
		{
			value = this._dataElements[ i ].getValue();

			if ( insertValue < value )
			{
				return i;
			}
		}
		return i;
	}

	//******************************************************
	function renderAll( )
	{
		this.renderFrom( 0 , this._size );
	}


	//******************************************************
	function renderFrom( renderIndex , renderToIndex )
	{
		var i = 0;
		var index = this._formElement.getSelectedIndex();
		for ( ; i < renderToIndex ; i++ )
		{
			if ( this.optionChanged( i ) )
			{
				this.setOption( i );
			}			
		}
		this._formElement.setSelectedIndex( index );
	}


	//******************************************************
	function setOption( index )
	{
		var option = this._dataElements[ index ].getOption();
		this._formElement.setSelectOption( option , index );
	}

	//******************************************************
	function optionChanged( index )
	{
		var value = null;
		if ( index < 0 || index > this._size)
		{
			return false;
		}
		else
		{						
			value = this._formElement.getOptionValue( index );
			if ( this._dataElements[ index ] != null )
			{
				return ( value != this._dataElements[ index ].getValue() );
			}
			else
			{
				return true;
			}
		}
	}

	//******************************************************
	function displaySelectedOption()
	{
		var index = this._formElement.getSelectedIndex();
		if ( index < 0 )
		{
			this._formElement.clearDisplayElement();
		}
		else
		{
			if ( this._size == 0 )
			{
				this._formElement.clearSelect();
			}
			else
			{
				this._dataElements[ index ].display();
			}
		}
	}


	//******************************************************
	function shiftDataUpFrom( index )
	{
		var i = index;
		var item = null;

		for ( ; i < ( this._size - 1 ) ; i++ )
		{
			item = this._dataElements[ i + 1 ];
			item.setSequenceNumber( i );
			this._dataElements[ i ] = item;
		}
		this._size--;
	}

	//******************************************************
	function shiftDataDownFrom( fromIndex )
	{

		var i = this._size - 1;

		var newSeqNum = 0;
		var dataItem = null;


		if ( fromIndex == this._size )
		{
		
		}
		else
		{
			for ( ; i >= fromIndex ; i-- )
			{
				newSeqNum = i + 1;
				dataItem = this._dataElements[ i ];
				dataItem.setSequenceNumber( newSeqNum );
				this._dataElements[ newSeqNum ] = dataItem;
			}
		}
		this._size++;
	}


	//******************************************************
	function encodeViewDataList( formElement , type )
	{
		var value = formElement.value;
		var string = type + "\n";

		if ( this._size > 0 )
		{
			 string += "{\n";
		}

		var i = 0;

		if ( this._size > 0 )
		{
			for ( ; i < this._size ; i++ )
			{
				string += this._dataElements[ i ].encode();		
			}
			string += "\n}\n";
		}

		value += string;
		
		formElement.value = value;
	}


	//******************************************************
	NCOWebtopViewDataList.prototype.update = update;
	NCOWebtopViewDataList.prototype.addDataItem = addDataItem;
	NCOWebtopViewDataList.prototype.removeSelectedItem = removeSelectedItem;
	NCOWebtopViewDataList.prototype.removeItem = removeItem;
	NCOWebtopViewDataList.prototype.removeAllItems = removeAllDataItems;
	NCOWebtopViewDataList.prototype.moveToTop = moveListItemToTop;
	NCOWebtopViewDataList.prototype.moveToBottom = moveListItemToBottom;
	NCOWebtopViewDataList.prototype.moveUp = moveListItemUp;
	NCOWebtopViewDataList.prototype.moveDown = moveListItemDown;
	NCOWebtopViewDataList.prototype.swapItems = swapItems;
	NCOWebtopViewDataList.prototype.addDataItems = addDataItems;
	NCOWebtopViewDataList.prototype.insertDataItem = insertDataItem;
	NCOWebtopViewDataList.prototype.getInsertIndex = getInsertIndex;
	NCOWebtopViewDataList.prototype.renderAll = renderAll;
	NCOWebtopViewDataList.prototype.renderFrom = renderFrom;
	NCOWebtopViewDataList.prototype.setOption = setOption;
	NCOWebtopViewDataList.prototype.optionChanged = optionChanged;
	NCOWebtopViewDataList.prototype.shiftDataDownFrom = shiftDataDownFrom;
	NCOWebtopViewDataList.prototype.displaySelectedOption = displaySelectedOption;
	NCOWebtopViewDataList.prototype.shiftDataUpFrom = shiftDataUpFrom;
	NCOWebtopViewDataList.prototype.updateSelected = updateSelected;
	NCOWebtopViewDataList.prototype.encode = encodeViewDataList;
	// NBS 27918
	NCOWebtopViewDataList.prototype.updateIndex = updateIndex;

